//
// SqlMethods.cs
//
// Author:
//   Atsushi Enomoto  <atsushi@ximian.com>
//
// Copyright (C) 2008 Novell, Inc.
//

//
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//
using System;

namespace System.Data.Linq.SqlClient
{
	public static class SqlMethods
	{
        static Exception NotSupported()
        {
            return new NotSupportedException("The method in SqlMethods type cannot be used directly. It is only for Linq to SQL trsnslation");
        }

        [MonoTODO]
		public static int DateDiffDay (DateTime startDate, DateTime endDate)
		{
            throw NotSupported();
		}

		[MonoTODO]
		public static int? DateDiffDay (DateTime? startDate, DateTime? endDate)
		{
            throw NotSupported();
        }

		[MonoTODO]
		public static int DateDiffHour (DateTime startDate, DateTime endDate)
		{
            throw NotSupported();
        }

		[MonoTODO]
		public static int? DateDiffHour (DateTime? startDate, DateTime? endDate)
		{
            throw NotSupported();
        }

		[MonoTODO]
		public static int DateDiffMillisecond (DateTime startDate, DateTime endDate)
		{
            throw NotSupported();
        }

		[MonoTODO]
		public static int? DateDiffMillisecond (DateTime? startDate, DateTime? endDate)
		{
            throw NotSupported();
        }

		[MonoTODO]
		public static int DateDiffMinute (DateTime startDate, DateTime endDate)
		{
            throw NotSupported();
        }

		[MonoTODO]
		public static int? DateDiffMinute (DateTime? startDate, DateTime? endDate)
		{
            throw NotSupported();
        }

		[MonoTODO]
		public static int DateDiffMonth (DateTime startDate, DateTime endDate)
		{
            throw NotSupported();
        }

		[MonoTODO]
		public static int? DateDiffMonth (DateTime? startDate, DateTime? endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int DateDiffSecond (DateTime startDate, DateTime endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int? DateDiffSecond (DateTime? startDate, DateTime? endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int DateDiffYear (DateTime startDate, DateTime endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int? DateDiffYear (DateTime? startDate, DateTime? endDate)
		{
			throw NotSupported();
		}

		#region .NET 3.5 SP1 (DateTimeOffset)

		[MonoTODO]
		public static int DateDiffMicrosecond (DateTime startDate, DateTime endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int? DateDiffMicrosecond (DateTime? startDate, DateTime? endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int DateDiffNanosecond (DateTime startDate, DateTime endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int? DateDiffNanosecond (DateTime? startDate, DateTime? endDate)
		{
			throw NotSupported();
		}


		[MonoTODO]
		public static int DateDiffDay (DateTimeOffset startDate, DateTimeOffset endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int? DateDiffDay (DateTimeOffset? startDate, DateTimeOffset? endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int DateDiffHour (DateTimeOffset startDate, DateTimeOffset endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int? DateDiffHour (DateTimeOffset? startDate, DateTimeOffset? endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int DateDiffMicrosecond (DateTimeOffset startDate, DateTimeOffset endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int? DateDiffMicrosecond (DateTimeOffset? startDate, DateTimeOffset? endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int DateDiffMillisecond (DateTimeOffset startDate, DateTimeOffset endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int? DateDiffMillisecond (DateTimeOffset? startDate, DateTimeOffset? endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int DateDiffMinute (DateTimeOffset startDate, DateTimeOffset endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int? DateDiffMinute (DateTimeOffset? startDate, DateTimeOffset? endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int DateDiffMonth (DateTimeOffset startDate, DateTimeOffset endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int? DateDiffMonth (DateTimeOffset? startDate, DateTimeOffset? endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int DateDiffNanosecond (DateTimeOffset startDate, DateTimeOffset endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int? DateDiffNanosecond (DateTimeOffset? startDate, DateTimeOffset? endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int DateDiffSecond (DateTimeOffset startDate, DateTimeOffset endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int? DateDiffSecond (DateTimeOffset? startDate, DateTimeOffset? endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int DateDiffYear (DateTimeOffset startDate, DateTimeOffset endDate)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static int? DateDiffYear (DateTimeOffset? startDate, DateTimeOffset? endDate)
		{
			throw NotSupported();
		}
		#endregion

		[MonoTODO]
		public static bool Like (string matchExpression, string pattern)
		{
			throw NotSupported();
		}

		[MonoTODO]
		public static bool Like (string matchExpression, string pattern, char escapeCharacter)
		{
			throw NotSupported();
		}
	}
}
