﻿//------------------------------------------------------------------------------
//     Copyright (c) Microsoft Corporation.  All rights reserved.
//------------------------------------------------------------------------------

namespace System.Security.Claims
{
    /// <summary>
    /// Defines types for WindowsIdentity AuthenticationType
    /// </summary>
    public static class AuthenticationTypes
    {
#pragma warning disable 1591
        public const string Basic = "Basic";
        public const string Federation  = "Federation";
        public const string Kerberos    = "Kerberos";
        public const string Negotiate   = "Negotiate";
        public const string Password    = "Password";
        public const string Signature   = "Signature";
        public const string Windows     = "Windows";
        public const string X509        = "X509";
#pragma warning restore 1591

        // Types generated by CLR WindowsIdentity:
        //  :generated by NTAuthenticationInfoClass: NTLM, Kerberos, WDigest, Negotiate
        //  :generated by GetServerVariable("AUTH_TYPE"): Basic, Digest, Kerberos, NTLM, and RADIUS
    }
}
