﻿//------------------------------------------------------------------------------
// <copyright file="IMembershipAdapter.cs" company="Microsoft">
//    Copyright (c) Microsoft Corporation.  All rights reserved.
// </copyright>
//------------------------------------------------------------------------------

namespace System.Web.Security {
    using System;
    
    internal interface IMembershipAdapter {
        MembershipProviderCollection Providers {
            get;
        }

        int UserIsOnlineTimeWindow {
            get;
        }

        bool IsDecryptionKeyAutogenerated {
            get;
        }

        bool UsingCustomEncryption {
            get;
        }

        byte[] EncryptOrDecryptData(bool encrypt, byte[] buffer, bool useLegacyMode);
    }
}
