﻿// These suppressions are baselined from upgrading from FxCop 1.36 to FxCop 10.0.

using System.Diagnostics.CodeAnalysis;

#region Design and Naming
[module: SuppressMessage("Microsoft.Design", "CA1045:DoNotPassTypesByReference", MessageId = "3#", Scope = "member", Target = "System.Web.Configuration.IRemoteWebConfigurationHostServer.#WriteData(System.String,System.String,System.Byte[],System.Int64&)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Design", "CA1045:DoNotPassTypesByReference", MessageId = "1#", Scope = "member", Target = "System.Web.Hosting.IListenerChannelCallback.#GetBlob(System.Byte[],System.Int32&)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Design", "CA1045:DoNotPassTypesByReference", MessageId = "2#", Scope = "member", Target = "System.Web.Util.Transactions.#InvokeTransacted(System.Web.Util.TransactedCallback,System.EnterpriseServices.TransactionOption,System.Boolean&)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1720:IdentifiersShouldNotContainTypeNames", MessageId = "bytes", Scope = "member", Target = "System.Web.Util.HttpEncoder.#UrlEncode(System.Byte[],System.Int32,System.Int32)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1720:IdentifiersShouldNotContainTypeNames", MessageId = "short", Scope = "member", Target = "System.Web.UI.WebControls.BaseCompareValidator.#GetFullYear(System.Int32)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1720:IdentifiersShouldNotContainTypeNames", MessageId = "obj", Scope = "member", Target = "System.Web.UI.IParserAccessor.#AddParsedSubObject(System.Object)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1720:IdentifiersShouldNotContainTypeNames", MessageId = "obj", Scope = "member", Target = "System.Web.UI.Control.#AddParsedSubObject(System.Object)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1720:IdentifiersShouldNotContainTypeNames", MessageId = "bytes", Scope = "member", Target = "System.Web.HttpUtility.#UrlEncodeToBytes(System.Byte[],System.Int32,System.Int32)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1720:IdentifiersShouldNotContainTypeNames", MessageId = "bytes", Scope = "member", Target = "System.Web.HttpUtility.#UrlEncodeToBytes(System.Byte[])", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1720:IdentifiersShouldNotContainTypeNames", MessageId = "bytes", Scope = "member", Target = "System.Web.HttpUtility.#UrlEncode(System.Byte[],System.Int32,System.Int32)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1720:IdentifiersShouldNotContainTypeNames", MessageId = "bytes", Scope = "member", Target = "System.Web.HttpUtility.#UrlEncode(System.Byte[])", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1720:IdentifiersShouldNotContainTypeNames", MessageId = "bytes", Scope = "member", Target = "System.Web.HttpUtility.#UrlDecodeToBytes(System.Byte[],System.Int32,System.Int32)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1720:IdentifiersShouldNotContainTypeNames", MessageId = "bytes", Scope = "member", Target = "System.Web.HttpUtility.#UrlDecodeToBytes(System.Byte[])", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1720:IdentifiersShouldNotContainTypeNames", MessageId = "bytes", Scope = "member", Target = "System.Web.HttpUtility.#UrlDecode(System.Byte[],System.Text.Encoding)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1720:IdentifiersShouldNotContainTypeNames", MessageId = "bytes", Scope = "member", Target = "System.Web.HttpUtility.#UrlDecode(System.Byte[],System.Int32,System.Int32,System.Text.Encoding)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1720:IdentifiersShouldNotContainTypeNames", MessageId = "obj", Scope = "member", Target = "System.Web.HttpResponse.#Write(System.Object)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1716:IdentifiersShouldNotMatchKeywords", MessageId = "Get", Scope = "member", Target = "System.Web.Caching.OutputCacheProvider.#Get(System.String)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1716:IdentifiersShouldNotMatchKeywords", MessageId = "Set", Scope = "member", Target = "System.Web.Caching.OutputCacheProvider.#Set(System.String,System.Object,System.DateTime)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1716:IdentifiersShouldNotMatchKeywords", MessageId = "Error", Scope = "member", Target = "System.Web.Compilation.ClientBuildManagerCallback.#ReportCompilerError(System.CodeDom.Compiler.CompilerError)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1716:IdentifiersShouldNotMatchKeywords", MessageId = "Error", Scope = "member", Target = "System.Web.Compilation.ClientBuildManagerCallback.#ReportParseError(System.Web.ParserError)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1716:IdentifiersShouldNotMatchKeywords", MessageId = "Module", Scope = "member", Target = "System.Web.Hosting.IAppDomainFactory.#Create(System.String,System.String,System.String,System.String,System.String,System.Int32)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1716:IdentifiersShouldNotMatchKeywords", MessageId = "Stop", Scope = "member", Target = "System.Web.Hosting.IAppManagerAppDomainFactory.#Stop()", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1716:IdentifiersShouldNotMatchKeywords", MessageId = "Stop", Scope = "member", Target = "System.Web.Hosting.IRegisteredObject.#Stop(System.Boolean)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1716:IdentifiersShouldNotMatchKeywords", MessageId = "Select", Scope = "member", Target = "System.Web.UI.DataSourceView.#Select(System.Web.UI.DataSourceSelectArguments,System.Web.UI.DataSourceViewSelectCallback)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1716:IdentifiersShouldNotMatchKeywords", MessageId = "Select", Scope = "member", Target = "System.Web.UI.HierarchicalDataSourceView.#Select()", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1716:IdentifiersShouldNotMatchKeywords", MessageId = "GetType", Scope = "member", Target = "System.Web.UI.IUserControlTypeResolutionService.#GetType(System.String,System.String)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1716:IdentifiersShouldNotMatchKeywords", MessageId = "Select", Scope = "member", Target = "System.Web.UI.HtmlControls.HtmlSelect.#Select(System.Int32[])", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1716:IdentifiersShouldNotMatchKeywords", MessageId = "ReadOnly", Scope = "member", Target = "System.Web.UI.WebControls.BoundColumn.#ReadOnly", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1716:IdentifiersShouldNotMatchKeywords", MessageId = "ReadOnly", Scope = "member", Target = "System.Web.UI.WebControls.BoundField.#ReadOnly", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1716:IdentifiersShouldNotMatchKeywords", MessageId = "ReadOnly", Scope = "member", Target = "System.Web.UI.WebControls.ImageField.#ReadOnly", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1716:IdentifiersShouldNotMatchKeywords", MessageId = "ReadOnly", Scope = "member", Target = "System.Web.UI.WebControls.TextBox.#ReadOnly", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Design", "CA1058:TypesShouldNotExtendCertainBaseTypes", Scope = "type", Target = "System.Web.UI.WebControls.WebParts.WebPartZoneCollection", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Design", "CA1058:TypesShouldNotExtendCertainBaseTypes", Scope = "type", Target = "System.Web.UI.WebControls.WebParts.WebPartVerbCollection", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Design", "CA1058:TypesShouldNotExtendCertainBaseTypes", Scope = "type", Target = "System.Web.UI.WebControls.WebParts.WebPartTransformerCollection", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Design", "CA1058:TypesShouldNotExtendCertainBaseTypes", Scope = "type", Target = "System.Web.UI.WebControls.WebParts.WebPartDisplayModeCollection", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Design", "CA1058:TypesShouldNotExtendCertainBaseTypes", Scope = "type", Target = "System.Web.UI.WebControls.WebParts.WebPartDescriptionCollection", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Design", "CA1058:TypesShouldNotExtendCertainBaseTypes", Scope = "type", Target = "System.Web.UI.WebControls.WebParts.WebPartConnectionCollection", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Design", "CA1058:TypesShouldNotExtendCertainBaseTypes", Scope = "type", Target = "System.Web.UI.WebControls.WebParts.WebPartCollection", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Design", "CA1058:TypesShouldNotExtendCertainBaseTypes", Scope = "type", Target = "System.Web.UI.WebControls.WebParts.TransformerTypeCollection", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Design", "CA1058:TypesShouldNotExtendCertainBaseTypes", Scope = "type", Target = "System.Web.UI.WebControls.WebParts.ProxyWebPartConnectionCollection", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Design", "CA1058:TypesShouldNotExtendCertainBaseTypes", Scope = "type", Target = "System.Web.UI.WebControls.WebParts.ProviderConnectionPointCollection", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Design", "CA1058:TypesShouldNotExtendCertainBaseTypes", Scope = "type", Target = "System.Web.UI.WebControls.WebParts.EditorPartCollection", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Design", "CA1058:TypesShouldNotExtendCertainBaseTypes", Scope = "type", Target = "System.Web.UI.WebControls.WebParts.ConsumerConnectionPointCollection", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Design", "CA1058:TypesShouldNotExtendCertainBaseTypes", Scope = "type", Target = "System.Web.UI.WebControls.WebParts.ConnectionInterfaceCollection", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Design", "CA1058:TypesShouldNotExtendCertainBaseTypes", Scope = "type", Target = "System.Web.UI.WebControls.WebParts.CatalogPartCollection", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Design", "CA1058:TypesShouldNotExtendCertainBaseTypes", Scope = "type", Target = "System.Web.UI.WebControls.RoleGroupCollection", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Design", "CA1058:TypesShouldNotExtendCertainBaseTypes", Scope = "type", Target = "System.Web.UI.WebControls.EmbeddedMailObjectsCollection", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Design", "CA1058:TypesShouldNotExtendCertainBaseTypes", Scope = "type", Target = "System.Web.Management.WebBaseEventCollection", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Design", "CA1058:TypesShouldNotExtendCertainBaseTypes", Scope = "type", Target = "System.Web.ParserErrorCollection", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1702:CompoundWordsShouldBeCasedCorrectly", MessageId = "username", Scope = "member", Target = "System.Web.UI.WebControls.WebParts.PersonalizationStateInfoCollection.#Item[System.String,System.String]", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1702:CompoundWordsShouldBeCasedCorrectly", MessageId = "MultiLine", Scope = "member", Target = "System.Web.UI.WebControls.TextBoxMode.#MultiLine", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1702:CompoundWordsShouldBeCasedCorrectly", MessageId = "HRef", Scope = "member", Target = "System.Web.UI.HtmlControls.HtmlAnchor.#HRef", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1702:CompoundWordsShouldBeCasedCorrectly", MessageId = "Stylesheet", Scope = "member", Target = "System.Web.UI.IThemeResolutionService.#GetStylesheetThemeProvider()", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1702:CompoundWordsShouldBeCasedCorrectly", MessageId = "Readonly", Scope = "member", Target = "System.Web.SessionState.HttpSessionStateContainer.#.ctor(System.String,System.Web.SessionState.ISessionStateItemCollection,System.Web.HttpStaticObjectsCollection,System.Int32,System.Boolean,System.Web.HttpCookieMode,System.Web.SessionState.SessionStateMode,System.Boolean)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1702:CompoundWordsShouldBeCasedCorrectly", MessageId = "tOld", Scope = "member", Target = "System.Web.Security.FormsAuthentication.#RenewTicketIfOld(System.Web.Security.FormsAuthenticationTicket)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1702:CompoundWordsShouldBeCasedCorrectly", MessageId = "SubPath", Scope = "member", Target = "System.Web.Configuration.WebContext.#LocationSubPath", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1702:CompoundWordsShouldBeCasedCorrectly", MessageId = "SubPath", Scope = "member", Target = "System.Web.Configuration.WebContext.#.ctor(System.Web.Configuration.WebApplicationLevel,System.String,System.String,System.String,System.String,System.String)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1702:CompoundWordsShouldBeCasedCorrectly", MessageId = "SubPath", Scope = "member", Target = "System.Web.Configuration.WebConfigurationManager.#OpenWebConfiguration(System.String,System.String,System.String,System.String,System.String,System.String)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1702:CompoundWordsShouldBeCasedCorrectly", MessageId = "SubPath", Scope = "member", Target = "System.Web.Configuration.WebConfigurationManager.#OpenWebConfiguration(System.String,System.String,System.String,System.String,System.IntPtr)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1702:CompoundWordsShouldBeCasedCorrectly", MessageId = "SubPath", Scope = "member", Target = "System.Web.Configuration.WebConfigurationManager.#OpenWebConfiguration(System.String,System.String,System.String,System.String)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1702:CompoundWordsShouldBeCasedCorrectly", MessageId = "SubPath", Scope = "member", Target = "System.Web.Configuration.WebConfigurationManager.#OpenWebConfiguration(System.String,System.String,System.String)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1702:CompoundWordsShouldBeCasedCorrectly", MessageId = "SubPath", Scope = "member", Target = "System.Web.Configuration.WebConfigurationManager.#OpenMappedWebConfiguration(System.Web.Configuration.WebConfigurationFileMap,System.String,System.String,System.String)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1702:CompoundWordsShouldBeCasedCorrectly", MessageId = "SubPath", Scope = "member", Target = "System.Web.Configuration.WebConfigurationManager.#OpenMappedMachineConfiguration(System.Configuration.ConfigurationFileMap,System.String)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1702:CompoundWordsShouldBeCasedCorrectly", MessageId = "SubPath", Scope = "member", Target = "System.Web.Configuration.WebConfigurationManager.#OpenMachineConfiguration(System.String,System.String,System.String,System.String)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1702:CompoundWordsShouldBeCasedCorrectly", MessageId = "SubPath", Scope = "member", Target = "System.Web.Configuration.WebConfigurationManager.#OpenMachineConfiguration(System.String,System.String,System.IntPtr)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1702:CompoundWordsShouldBeCasedCorrectly", MessageId = "SubPath", Scope = "member", Target = "System.Web.Configuration.WebConfigurationManager.#OpenMachineConfiguration(System.String,System.String)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1702:CompoundWordsShouldBeCasedCorrectly", MessageId = "SubPath", Scope = "member", Target = "System.Web.Configuration.WebConfigurationManager.#OpenMachineConfiguration(System.String)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1702:CompoundWordsShouldBeCasedCorrectly", MessageId = "SubPath", Scope = "member", Target = "System.Web.Configuration.IRemoteWebConfigurationHostServer.#GetFilePaths(System.Int32,System.String,System.String,System.String)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "System.Web.UI.WebControls.WebParts.WebPartAuthorizationEventArgs.#Type", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "System.Web.UI.WebControls.Unit.#Type", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "System.Web.UI.WebControls.Parameter.#Type", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "System.Web.UI.WebControls.FontUnit.#Type", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "System.Web.UI.WebControls.BaseCompareValidator.#Type", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "System.Web.UI.WebControls.AutoGeneratedFieldProperties.#Type", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "System.Web.UI.HtmlControls.HtmlInputControl.#Type", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "System.Web.UI.PropertyEntry.#Type", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "System.Web.Configuration.TransformerInfo.#Type", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "System.Web.Configuration.ProfilePropertySettings.#Type", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "System.Web.Configuration.HttpModuleAction.#Type", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "System.Web.Configuration.HttpHandlerAction.#Type", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "System.Web.Configuration.HttpCapabilitiesBase.#Type", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "System.Web.Configuration.FolderLevelBuildProvider.#Type", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "System.Web.Configuration.ExpressionBuilder.#Type", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "System.Web.Configuration.EventMappingSettings.#Type", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "System.Web.Configuration.Compiler.#Type", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "System.Web.Configuration.BuildProvider.#Type", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "System.Web.Compilation.BuildDependencySet.#HashCode", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "System.Web.PreApplicationStartMethodAttribute.#Type", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "cb", Scope = "type", Target = "System.Web.BeginEventHandler", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "bh", Scope = "member", Target = "System.Web.HttpApplication.#AddOnLogRequestAsync(System.Web.BeginEventHandler,System.Web.EndEventHandler)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "bh", Scope = "member", Target = "System.Web.HttpApplication.#AddOnMapRequestHandlerAsync(System.Web.BeginEventHandler,System.Web.EndEventHandler)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "bh", Scope = "member", Target = "System.Web.HttpApplication.#AddOnPostLogRequestAsync(System.Web.BeginEventHandler,System.Web.EndEventHandler)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "ch", Scope = "member", Target = "System.Web.HttpResponse.#Write(System.Char)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "wr", Scope = "type", Target = "System.Web.HttpWorkerRequest+EndOfSendNotification", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "Platformmac", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Platformmac68kProcessBrowsers(System.Boolean,System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "Platformmac", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Platformmac68kProcessGateways(System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "Platformwin", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Platformwin16ProcessBrowsers(System.Boolean,System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "Platformwin", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Platformwin16ProcessGateways(System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "Platformwin", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Platformwin2000aProcessBrowsers(System.Boolean,System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "Platformwin", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Platformwin2000aProcessGateways(System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "Platformwin", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Platformwin2000bProcessBrowsers(System.Boolean,System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "Platformwin", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Platformwin2000bProcessGateways(System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "Platformwin", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Platformwin95ProcessBrowsers(System.Boolean,System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "Platformwin", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Platformwin95ProcessGateways(System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "Platformwin", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Platformwin98ProcessBrowsers(System.Boolean,System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "i", Scope = "member", Target = "System.Web.UI.WebControls.ViewCollection.#Item[System.Int32]", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "n", Scope = "member", Target = "System.Web.UI.WebControls.Unit.#op_Implicit(System.Int32):System.Web.UI.WebControls.Unit", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "i", Scope = "member", Target = "System.Web.UI.WebControls.TreeNodeStyleCollection.#Item[System.Int32]", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "i", Scope = "member", Target = "System.Web.UI.WebControls.TreeNodeBindingCollection.#Item[System.Int32]", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "i", Scope = "member", Target = "System.Web.UI.WebControls.SubMenuStyleCollection.#Item[System.Int32]", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "i", Scope = "member", Target = "System.Web.UI.WebControls.StyleCollection.#Item[System.Int32]", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "e", Scope = "type", Target = "System.Web.UI.WebControls.MonthChangedEventHandler", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "i", Scope = "member", Target = "System.Web.UI.WebControls.MenuItemStyleCollection.#Item[System.Int32]", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "i", Scope = "member", Target = "System.Web.UI.WebControls.MenuItemBindingCollection.#Item[System.Int32]", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "n", Scope = "member", Target = "System.Web.UI.WebControls.FontUnit.#op_Implicit(System.Int32):System.Web.UI.WebControls.FontUnit", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "e", Scope = "type", Target = "System.Web.UI.WebControls.DayRenderEventHandler", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "attr", Scope = "member", Target = "System.Web.UI.HtmlTextWriter.#GetAttributeName(System.Web.UI.HtmlTextWriterAttribute)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "attr", Scope = "member", Target = "System.Web.UI.HtmlTextWriter.#GetAttributeKey(System.String)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "attr", Scope = "member", Target = "System.Web.UI.HtmlTextWriter.#EncodeAttributeValue(System.Web.UI.HtmlTextWriterAttribute,System.String)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1704:IdentifiersShouldBeSpelledCorrectly", MessageId = "Platformwin", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Platformwin98ProcessGateways(System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "Md", Scope = "member", Target = "System.Web.HttpWorkerRequest.#HeaderContentMd5", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "ID", Scope = "member", Target = "System.Web.ProcessInfo.#.ctor(System.DateTime,System.TimeSpan,System.Int32,System.Int32,System.Web.ProcessStatus,System.Web.ProcessShutdownReason,System.Int32)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "Ie", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Ie6to9ProcessBrowsers(System.Boolean,System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "to", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Ie6to9ProcessBrowsers(System.Boolean,System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "Ie", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Ie6to9ProcessGateways(System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "to", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Ie6to9ProcessGateways(System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "Ie", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Ie7ProcessBrowsers(System.Boolean,System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "Ie", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Ie7ProcessGateways(System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "Ie", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Ie8ProcessBrowsers(System.Boolean,System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "Ie", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Ie8ProcessGateways(System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "to", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Opera8to9ProcessBrowsers(System.Boolean,System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "to", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Opera8to9ProcessGateways(System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "k", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Platformmac68kProcessBrowsers(System.Boolean,System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "k", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Platformmac68kProcessGateways(System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "a", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Platformwin2000aProcessBrowsers(System.Boolean,System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "a", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Platformwin2000aProcessGateways(System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "b", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Platformwin2000bProcessBrowsers(System.Boolean,System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "b", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Platformwin2000bProcessGateways(System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "to", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Safari3to4ProcessBrowsers(System.Boolean,System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "to", Scope = "member", Target = "System.Web.Configuration.BrowserCapabilitiesFactory.#Safari3to4ProcessGateways(System.Collections.Specialized.NameValueCollection,System.Web.HttpBrowserCapabilities)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "SHA", Scope = "member", Target = "System.Web.Configuration.FormsAuthPasswordFormat.#SHA1", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "SHA", Scope = "member", Target = "System.Web.Configuration.MachineKeyValidation.#SHA1", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "ID", Scope = "member", Target = "System.Web.UI.StaticPartialCachingControl.#.ctor(System.String,System.String,System.Int32,System.String,System.String,System.String,System.String,System.Web.UI.BuildMethod,System.String)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "ID", Scope = "member", Target = "System.Web.UI.StaticPartialCachingControl.#.ctor(System.String,System.String,System.Int32,System.String,System.String,System.String,System.Web.UI.BuildMethod)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "UTF", Scope = "member", Target = "System.Web.UI.TemplateControl.#WriteUTF8ResourceString(System.Web.UI.HtmlTextWriter,System.Int32,System.Int32,System.Boolean)", Justification = "This API previously shipped; modification would be a breaking change.")]
[module: SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "ID", Scope = "member", Target = "System.Web.UI.WebControls.ControlParameter.#.ctor(System.String,System.Data.DbType,System.String,System.String)", Justification = "This API previously shipped; modification would be a breaking change.")]
#endregion

#region Security, Usage, and other reviewed items
[module: SuppressMessage("Microsoft.Security", "CA2123:OverrideLinkDemandsShouldBeIdenticalToBase", Scope = "member", Target = "System.Web.UI.PageHandlerFactory.#ReleaseHandler(System.Web.IHttpHandler)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2123:OverrideLinkDemandsShouldBeIdenticalToBase", Scope = "member", Target = "System.Web.UI.PageHandlerFactory.#GetHandler(System.Web.HttpContext,System.String,System.String,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2123:OverrideLinkDemandsShouldBeIdenticalToBase", Scope = "member", Target = "System.Web.Security.ActiveDirectoryMembershipProvider.#Initialize(System.String,System.Collections.Specialized.NameValueCollection)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2123:OverrideLinkDemandsShouldBeIdenticalToBase", Scope = "member", Target = "System.Web.Management.SqlExecutionException.#GetObjectData(System.Runtime.Serialization.SerializationInfo,System.Runtime.Serialization.StreamingContext)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2123:OverrideLinkDemandsShouldBeIdenticalToBase", Scope = "member", Target = "System.Web.Compilation.ClientBuildManager.#System.IDisposable.Dispose()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Reliability", "CA2002:DoNotLockOnObjectsWithWeakIdentity", Scope = "member", Target = "System.Web.Hosting.ProcessHost.#get_ProtocolsConfig()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Reliability", "CA2002:DoNotLockOnObjectsWithWeakIdentity", Scope = "member", Target = "System.Web.Hosting.HostingEnvironment.#StopWellKnownObject(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Reliability", "CA2002:DoNotLockOnObjectsWithWeakIdentity", Scope = "member", Target = "System.Web.Hosting.HostingEnvironment.#GetSiteName()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Reliability", "CA2002:DoNotLockOnObjectsWithWeakIdentity", Scope = "member", Target = "System.Web.Hosting.HostingEnvironment.#GetSiteID()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Reliability", "CA2002:DoNotLockOnObjectsWithWeakIdentity", Scope = "member", Target = "System.Web.Hosting.HostingEnvironment.#FindWellKnownObject(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Reliability", "CA2002:DoNotLockOnObjectsWithWeakIdentity", Scope = "member", Target = "System.Web.Hosting.HostingEnvironment.#CreateWellKnownObjectInstance(System.String,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Reliability", "CA2002:DoNotLockOnObjectsWithWeakIdentity", Scope = "member", Target = "System.Web.Hosting.ApplicationManager.#GetLockableAppDomainContext(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Reliability", "CA2002:DoNotLockOnObjectsWithWeakIdentity", Scope = "member", Target = "System.Web.Hosting.ApplicationManager.#CloneAppDomainsCollection()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1816:CallGCSuppressFinalizeCorrectly", Scope = "member", Target = "System.Web.HttpApplication.#Dispose()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1816:CallGCSuppressFinalizeCorrectly", Scope = "member", Target = "System.Web.HttpResponseUnmanagedBufferElement.#ForceRecycle()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1816:CallGCSuppressFinalizeCorrectly", Scope = "member", Target = "System.Web.ImpersonationContext.#System.IDisposable.Dispose()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1816:CallGCSuppressFinalizeCorrectly", Scope = "member", Target = "System.Web.ImpersonationContext.#Undo()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1816:CallGCSuppressFinalizeCorrectly", Scope = "member", Target = "System.Web.Caching.CacheDependency.#Dispose()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1816:CallGCSuppressFinalizeCorrectly", Scope = "member", Target = "System.Web.Configuration.MULTI_QI.#System.IDisposable.Dispose()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1816:CallGCSuppressFinalizeCorrectly", Scope = "member", Target = "System.Web.Configuration.MULTI_QI_X64.#System.IDisposable.Dispose()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1816:CallGCSuppressFinalizeCorrectly", Scope = "member", Target = "System.Web.UI.BasePartialCachingControl.#Dispose()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1816:CallGCSuppressFinalizeCorrectly", Scope = "member", Target = "System.Web.UI.Control.#Dispose()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1816:CallGCSuppressFinalizeCorrectly", Scope = "member", Target = "System.Web.UI.WebControls.Style.#.ctor(System.Web.UI.StateBag)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.UnsafeNativeMethods.GrowFileNotificationBuffer(System.String,System.Boolean)", Scope = "member", Target = "System.Web.DirectoryMonitor.#OnFileChange(System.Web.FileAction,System.String,System.DateTime)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.Hosting.UnsafeIISMethods.MgdEtwGetTraceConfig(System.IntPtr,System.Boolean@,System.Int32@,System.Int32@)", Scope = "member", Target = "System.Web.EtwTrace.#TraceEnableCheck(System.Web.EtwTraceConfigType,System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.UnsafeNativeMethods.EcbGetTraceFlags(System.IntPtr,System.Int32[])", Scope = "member", Target = "System.Web.EtwTrace.#TraceEnableCheck(System.Web.EtwTraceConfigType,System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.UnsafeNativeMethods.RevertToSelf", Scope = "member", Target = "System.Web.ImpersonationContext.#RestoreImpersonation()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.Hosting.UnsafeIISMethods.MgdFlushKernelCache(System.String)", Scope = "member", Target = "System.Web.Caching.OutputCache.#DependencyRemovedCallback(System.String,System.Object,System.Web.Caching.CacheItemRemovedReason)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.Hosting.UnsafeIISMethods.MgdFlushKernelCache(System.String)", Scope = "member", Target = "System.Web.Caching.OutputCache.#EntryRemovedCallback(System.String,System.Object,System.Web.Caching.CacheItemRemovedReason)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.Hosting.UnsafeIISMethods.MgdSetNativeConfiguration(System.IntPtr)", Scope = "member", Target = "System.Web.Configuration.ProcessHostMapPath.#.ctor(System.Web.Hosting.IProcessHostSupportFunctions)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.Hosting.UnsafeIISMethods.MgdSetNativeConfiguration(System.IntPtr)", Scope = "member", Target = "System.Web.Configuration.ProcessHostServerConfig.#.ctor()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.UnsafeNativeMethods.GetPrivateBytesIIS6(System.Int64@,System.Boolean)", Scope = "member", Target = "System.Web.Hosting.CacheManager.#NextSample()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.UnsafeNativeMethods.GetProcessMemoryInformation(System.UInt32,System.UInt32@,System.UInt32@,System.Boolean)", Scope = "member", Target = "System.Web.Hosting.CacheManager.#NextSample()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.Hosting.UnsafeIISMethods.MgdGetRequestTraceGuid(System.IntPtr,System.Guid@)", Scope = "member", Target = "System.Web.Hosting.IIS7WorkerRequest.#.ctor(System.IntPtr,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.Hosting.UnsafeIISMethods.MgdClearResponse(System.IntPtr,System.Boolean,System.Boolean)", Scope = "member", Target = "System.Web.Hosting.IIS7WorkerRequest.#ClearResponse(System.Boolean,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.Hosting.UnsafeIISMethods.MgdEmitSimpleTrace(System.IntPtr,System.Int32,System.String)", Scope = "member", Target = "System.Web.Hosting.IIS7WorkerRequest.#RaiseTraceEvent(System.Web.IntegratedTraceType,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.Hosting.UnsafeIISMethods.MgdEmitWebEventTrace(System.IntPtr,System.Int32,System.Int32,System.String[],System.Int32[],System.String[])", Scope = "member", Target = "System.Web.Hosting.IIS7WorkerRequest.#RaiseTraceEvent(System.Web.Management.WebBaseEvent)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.Hosting.UnsafeIISMethods.MgdRewriteUrl(System.IntPtr,System.String,System.Boolean)", Scope = "member", Target = "System.Web.Hosting.IIS7WorkerRequest.#RewriteNotifyPipeline(System.String,System.String,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.UnsafeNativeMethods.EcbFlushCore(System.IntPtr,System.Byte[],System.Byte[],System.Int32,System.Int32,System.Int32,System.IntPtr[],System.Int32[],System.Int32,System.Int32,System.Int32,System.Int32,System.Web.Hosting.ISAPIAsyncCompletionCallback)", Scope = "member", Target = "System.Web.Hosting.ISAPIWorkerRequestInProc.#FlushCore(System.Byte[],System.Byte[],System.Int32,System.Int32,System.Int32,System.IntPtr[],System.Int32[],System.Int32,System.Int32,System.Boolean&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.UnsafeNativeMethods.EcbFlushCore(System.IntPtr,System.Byte[],System.Byte[],System.Int32,System.Int32,System.Int32,System.IntPtr[],System.Int32[],System.Int32,System.Int32,System.Int32,System.Int32,System.Web.Hosting.ISAPIAsyncCompletionCallback)", Scope = "member", Target = "System.Web.Hosting.ISAPIWorkerRequestInProcForIIS6.#FlushCore(System.Byte[],System.Byte[],System.Int32,System.Int32,System.Int32,System.IntPtr[],System.Int32[],System.Int32,System.Int32,System.Boolean&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.UnsafeNativeMethods.AspCompatOnPageEnd", Scope = "member", Target = "System.Web.Util.AspCompatApplicationStep.#OnAspCompatExecution()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.Security.NativeMethods.NetApiBufferFree(System.IntPtr)", Scope = "member", Target = "System.Web.Security.DirectoryInformation.#GetPdcIfDomain(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.Hosting.UnsafeIISMethods.MgdAppDomainShutdown(System.IntPtr)", Scope = "member", Target = "System.Web.Hosting.PipelineRuntime.#RemoveThisAppDomainFromUnmanagedTable()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.UnsafeNativeMethods.PMEmptyResponse(System.IntPtr)", Scope = "member", Target = "System.Web.Hosting.ISAPIWorkerRequestOutOfProc.#SendEmptyResponse()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.UnsafeNativeMethods.PMFlushCore(System.IntPtr,System.Byte[],System.Byte[],System.Int32,System.Int32,System.Int32,System.Int32,System.IntPtr[],System.Int32[],System.Int32,System.Int32)", Scope = "member", Target = "System.Web.Hosting.ISAPIWorkerRequestOutOfProc.#FlushCore(System.Byte[],System.Byte[],System.Int32,System.Int32,System.Int32,System.IntPtr[],System.Int32[],System.Int32,System.Int32,System.Boolean&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.UnsafeNativeMethods.PMGetTraceContextId(System.IntPtr,System.Guid@)", Scope = "member", Target = "System.Web.Hosting.ISAPIWorkerRequestOutOfProc.#.ctor(System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.UnsafeNativeMethods.EcbEmitWebEventTrace(System.IntPtr,System.Int32,System.Int32,System.String[],System.Int32[],System.String[])", Scope = "member", Target = "System.Web.Hosting.ISAPIWorkerRequestInProcForIIS7.#RaiseTraceEvent(System.Web.Management.WebBaseEvent)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.UnsafeNativeMethods.EcbEmitSimpleTrace(System.IntPtr,System.Int32,System.String)", Scope = "member", Target = "System.Web.Hosting.ISAPIWorkerRequestInProcForIIS7.#RaiseTraceEvent(System.Web.IntegratedTraceType,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.UnsafeNativeMethods.EcbGetBasicsContentInfo(System.IntPtr,System.Int32[])", Scope = "member", Target = "System.Web.Hosting.ISAPIWorkerRequestInProcForIIS6.#ReadRequestBasics()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.UnsafeNativeMethods.RevertToSelf", Scope = "member", Target = "System.Web.Hosting.ISAPIWorkerRequestInProcForIIS6.#OnAsyncFlushCompletion(System.IntPtr,System.Int32,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA1806:DoNotIgnoreMethodResults", MessageId = "System.Web.UnsafeNativeMethods.EcbFlushCore(System.IntPtr,System.Byte[],System.Byte[],System.Int32,System.Int32,System.Int32,System.IntPtr[],System.Int32[],System.Int32,System.Int32,System.Int32,System.Int32,System.Web.Hosting.ISAPIAsyncCompletionCallback)", Scope = "member", Target = "System.Web.Hosting.ISAPIWorkerRequestInProcForIIS6.#OnAsyncFlushCompletion(System.IntPtr,System.Int32,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.CompilationUtil.#GetRecompilationHash(System.Web.Configuration.CompilationSection)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.CompilationUtil.#GetProviderOptions(System.Type)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.CompilationUtil.#CreateCodeDomProviderWithPropertyOptions(System.Type)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.CodeDomUtility.#PrependCompilerOption(System.CodeDom.Compiler.CompilerParameters,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.CodeDomUtility.#AppendCompilerOption(System.CodeDom.Compiler.CompilerParameters,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.CodeDirectoryCompiler.#GetCodeDirectoryAssembly(System.Web.VirtualPath,System.Web.Compilation.CodeDirectoryType,System.String,System.Web.Util.StringSet,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.BuildProvider.#GetCompilerTypeFromBuildProvider(System.Web.Compilation.BuildProvider)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.BuildManager.#ReportParseError(System.Web.ParserError)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.BuildManager.#ReportErrorsFromException(System.Exception)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.BuildManager.#ReportDirectoryCompilationProgress(System.Web.VirtualPath)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.AssemblyResolver.#get_WarnAsError()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.AssemblyResolver.#ReportWarningOrError(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.AssemblyBuilder.#get_OutputAssemblyName()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.AssemblyBuilder.#InvalidateInvalidAssembly(System.CodeDom.Compiler.CompilerResults,System.CodeDom.Compiler.CompilerParameters)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.AssemblyBuilder.#GetCompilerParameters()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.AssemblyBuilder.#FixTreatWarningsAsErrors(System.Type,System.CodeDom.Compiler.CompilerParameters)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.AssemblyBuilder.#CreateEmbeddedResource(System.Web.Compilation.BuildProvider,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.AssemblyBuilder.#CreateCodeFile(System.Web.Compilation.BuildProvider,System.String&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.AssemblyBuilder.#Compile()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.AssemblyBuilder.#AddVBMyFlags(System.CodeDom.Compiler.CompilerParameters)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.AssemblyBuilder.#AddVBGlobalNamespaceImports(System.CodeDom.Compiler.CompilerParameters)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.AssemblyBuilder.#AddCodeCompileUnit(System.Web.Compilation.BuildProvider,System.CodeDom.CodeCompileUnit)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.AssemblyBuilder.#AddChecksumPragma(System.Web.Compilation.BuildProvider,System.CodeDom.CodeCompileUnit)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.AssemblyBuilder.#.ctor(System.Web.Configuration.CompilationSection,System.Collections.ICollection,System.Web.Compilation.CompilerType,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.HttpRawUploadedContent+TempFile.#.ctor()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.HttpContext.#RestoreSavedAspNetSynchronizationContext(System.Web.AspNetSynchronizationContext)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.HttpContext.#InstallNewAspNetSynchronizationContext()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.ThreadContext.#AssociateWithCurrentThread(System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.CrossSiteScriptingValidation.#IsValidJavascriptId(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.TemplateParser.#ProcessBeginTag(System.Text.RegularExpressions.Match,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.TemplateParser.#PreprocessDirective(System.String,System.Collections.IDictionary)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.TemplateParser.#PageParserFilterProcessedEventHookupAttribute(System.String,System.String,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.TemplateParser.#PageParserFilterProcessedDataBindingAttribute(System.String,System.String,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.TemplateParser.#PageParserFilterProcessedCodeBlock(System.Web.UI.CodeConstructType,System.String,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.TemplateParser.#get_IsCodeAllowed()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.TemplateParser.#ImportSourceFile(System.Web.VirtualPath)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.TemplateParser.#HandlePostParse()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.TemplateParser.#AddSourceDependency(System.Web.VirtualPath)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.TemplateParser.#AddBuildResultDependency(System.Web.Compilation.BuildResult)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.MainTagNameToTypeMapper.#GetControlType2(System.String,System.Collections.IDictionary,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.ControlBuilder.#ProcessImplicitResources(System.Web.UI.ParsedAttributeCollection)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.ControlBuilder.#AttachTypeDescriptionProvider(System.Object)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.BaseTemplateParser.#GetUserControlType(System.Web.VirtualPath)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.BaseTemplateParser.#GetReferencedType(System.Web.VirtualPath,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Security.AuthorizationStoreRoleProvider.#InitApp()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Profile.ProfileModule.#PrepareDataForSaving(System.String&,System.String&,System.Byte[]&,System.Boolean,System.Configuration.SettingsPropertyValueCollection,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Profile.ProfileModule.#ParseDataFromDB(System.String[],System.String,System.Byte[],System.Configuration.SettingsPropertyValueCollection)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Management.WebProcessStatistics.#Update()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Management.RegiisUtility.#RemoveBrowserCaps(System.IntPtr&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.DataAccess.SqlConnectionHelper.#GetDataDirectory()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.DataAccess.SqlConnectionHelper.#CreateMdfFile(System.String,System.String,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Configuration.MachineKeySection.#RuntimeDataInitialize()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Configuration.Compiler.#get_CompilerTypeInternal()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Configuration.CompilationSection.#GetCompilerInfoFromLanguage(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Configuration.CompilationSection.#GetCompilerInfoFromExtension(System.String,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.WebDirectoryBatchCompiler.#CacheCompileErrors(System.Web.Compilation.AssemblyBuilder,System.CodeDom.Compiler.CompilerResults)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.CompilerType.#Equals(System.Object)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Compilation.CompilerType.#CloneCompilerParameters()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Util.VersionInfo.#GetFileVersion(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.Util.SecUtility.#GetDefaultAppName()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.WebControls.WebParts.WebPartMenuStyle.#System.ComponentModel.ICustomTypeDescriptor.GetProperties(System.Attribute[])", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.WebControls.WizardStepBase.#set_ID(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.WebControls.SubMenuStyle.#System.ComponentModel.ICustomTypeDescriptor.GetProperties(System.Attribute[])", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.Util.#GetNonEmptyFullClassNameAttribute(System.String,System.String,System.String&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.TemplateParser.#ProcessServerInclude(System.Text.RegularExpressions.Match)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.TemplateParser.#ProcessInheritsAttribute(System.String,System.String,System.String,System.Reflection.Assembly)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2122:DoNotIndirectlyExposeMethodsWithLinkDemands", Scope = "member", Target = "System.Web.UI.TemplateParser.#ProcessConfigSettings()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Compilation.CompilationUtil.#GetProviderOptions(System.Type)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Compilation.CompilationUtil.#GetProviderOptions(System.CodeDom.Compiler.CompilerInfo)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Compilation.CompilationUtil.#CreateCodeDomProviderWithPropertyOptions(System.Type)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Compilation.BuildManager.#ReadCachedFile(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Compilation.BuildManager.#InitializeBuildManager()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Compilation.BuildManager.#GetVPathBuildResultWithAssert(System.Web.HttpContext,System.Web.VirtualPath,System.Boolean,System.Boolean,System.Boolean,System.Boolean,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Compilation.BuildManager.#EnsureTopLevelFilesCompiled()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Compilation.BuildManager.#CreateCachedFile(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Compilation.AssemblyBuilder.#GetTempFilePhysicalPathWithAssert(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Compilation.AssemblyBuilder.#GetFileLengthWithAssert(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Compilation.AssemblyBuilder.#CreateTempResourceDirectoryIfNecessary()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Compilation.AssemblyBuilder.#CreateEmbeddedResource(System.Web.Compilation.BuildProvider,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Compilation.AssemblyBuilder.#CreateCodeFileWithAssert(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Caching.OutputCache.#Serialize(System.IO.Stream,System.Object)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Caching.OutputCache.#Deserialize(System.IO.Stream)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.StringResourceManager.#ReadSafeStringResource(System.Type)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.HttpRuntime.#ShutdownAppDomain(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.HttpRuntime.#SetCurrentThreadCultureWithAssert(System.Globalization.CultureInfo)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.HttpRuntime.#PreloadAssembliesFromBin()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.HttpRuntime.#CreateNonPublicInstance(System.Type,System.Object[])", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.HttpRuntime.#CheckAccessToTempDirectory()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.HttpResponse.#End()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.HttpRawUploadedContent+TempFile.#.ctor()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.HttpApplication.#SetCurrentPrincipalWithAssert(System.Security.Principal.IPrincipal)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.HttpApplication.#InvokeMethodWithAssert(System.Reflection.MethodInfo,System.Int32,System.Object,System.EventArgs)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.HttpApplication.#GetCurrentWindowsIdentityWithAssert()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.ErrorFormatter.#WriteFusionLogWithAssert(System.Text.StringBuilder)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.DirectoryMonitor.#StartMonitoringFileWithAssert(System.String,System.Web.FileChangeEventHandler,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.DefaultHttpHandler.#MapPathWithAssert(System.Web.HttpContext,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Profile.ProfileBase.#GetInternal(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Management.WebRequestInformation.#.ctor()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Management.WebBaseEvent.#RaiseSystemEventInternal(System.String,System.Object,System.Int32,System.Int32,System.Exception,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Management.MailWebEventProvider.#CreateSmtpClientWithAssert()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Hosting.ProcessHost.#ReportApplicationPreloadFailureWithAssert(System.String,System.Int32,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Hosting.ProcessHost.#GetApplicationPreloadInfoWithAssert(System.String,System.Boolean&,System.String&,System.String[]&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Hosting.IIS7WorkerRequest.#ScheduleExecuteUrl(System.String,System.String,System.String,System.Boolean,System.Byte[],System.Collections.Specialized.NameValueCollection)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Hosting.HostingEnvironment.#InitiateShutdownInternal()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Hosting.HostingEnvironment.#Initialize(System.Web.Hosting.ApplicationManager,System.Web.Hosting.IApplicationHost,System.Web.Configuration.IConfigMapPathFactory,System.Web.Hosting.HostingEnvironmentParameters,System.Security.Policy.PolicyLevel,System.Exception)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Hosting.HostingEnvironment.#GetSiteName()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Hosting.HostingEnvironment.#GetSiteID()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Hosting.HostingEnvironment.#CreateWellKnownObjectInstance(System.String,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Hosting.ApplicationManager.#CreateObjectInternal(System.String,System.Type,System.Web.Hosting.IApplicationHost,System.Boolean,System.Web.Hosting.HostingEnvironmentParameters)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Handlers.AssemblyResourceLoader.#GetDiskResourcePath(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Handlers.AssemblyResourceLoader.#GetAssemblyInfoWithAssertInternal(System.Reflection.Assembly)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.DataAccess.SqlConnectionHelper.#GetDataDirectory()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.DataAccess.SqlConnectionHelper.#CreateMdfFile(System.String,System.String,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Configuration.Common.ModulesEntry.#SecureGetType(System.String,System.String,System.Configuration.ConfigurationElement)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Configuration.ServerConfig.#get_UseMetabase()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Configuration.OutputCacheSection.#CreateProviderCollection()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Configuration.HttpHandlerAction.#InitValidateInternal()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Configuration.HttpConfigurationSystem.#get_MsCorLibDirectory()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Configuration.HttpCapabilitiesSectionHandler.#ResolveFiles(System.Web.Configuration.HttpCapabilitiesSectionHandler+ParseState,System.Object)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Configuration.HttpCapabilitiesDefaultProvider.#Evaluate(System.Web.HttpRequest)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Configuration.HealthMonitoringSectionHelper+ProviderInstances.#.ctor(System.Web.Configuration.HealthMonitoringSection)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Configuration.HealthMonitoringSectionHelper.#BasicSanityCheck()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Compilation.ThemeDirectoryCompiler.#GetThemeBuildResultType(System.Web.HttpContext,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Compilation.ObjectFactoryCodeDomTreeGenerator.#GetFastObjectCreationDelegate(System.Type)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Compilation.MultiTargetingUtil.#GetInstalledTargetVersion(System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.UI.Util.#IsUserAllowedToPathWithAssert(System.Web.HttpContext,System.Web.VirtualPath)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.UI.Util.#GetTypeFromAssemblies(System.Collections.IEnumerable,System.String,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.UI.Util.#GetAssemblyShortName(System.Reflection.Assembly)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.UI.Util.#GetAssemblyQualifiedTypeName(System.Type)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.UI.Util.#GetAssemblyCodeBase(System.Reflection.Assembly)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.UI.Util.#DeserializeWithAssert(System.Web.UI.IStateFormatter,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.UI.TemplateControl.#GetDelegateInformationWithAssert(System.Collections.IDictionary)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.UI.TemplateControl.#AddStackContextToHashCode(System.Web.Util.HashCodeCombiner)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.UI.Page.#ThreadResetAbortWithAssert()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.UI.Page.#SetCultureWithAssert(System.Threading.Thread,System.Globalization.CultureInfo,System.Globalization.CultureInfo)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.UI.Page.#ProcessRequestWithAssert(System.Web.HttpContext)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.UI.Page.#get_LastFocusedControl()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.UI.ObjectStateFormatter.#SerializeWithAssert(System.IO.Stream,System.Object)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.UI.ObjectStateFormatter.#DeserializeWithAssert(System.IO.Stream)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.SessionState.SessionStateModule.#SecureInstantiateProvider(System.Configuration.ProviderSettings)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.SessionState.SessionStateItemCollection.#WriteValueToStreamWithAssert(System.Object,System.IO.BinaryWriter)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.SessionState.SessionStateItemCollection.#ReadValueFromStreamWithAssert()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Security.WindowsTokenRoleProvider.#GetMachineName()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Security.WindowsTokenRoleProvider.#GetCurrentTokenAndCheckName(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Security.FileSecurityDescriptorWrapper.#get_AppRoot()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Security.DefaultAuthenticationModule.#CreateDefaultAuthenticationModuleWithAssert()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Security.AuthorizationStoreRoleProvider.#IsUserInRoleCore(System.String,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Security.AuthorizationStoreRoleProvider.#GetWindowsTokenWithAssert(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Security.AuthorizationStoreRoleProvider.#GetRolesForUserCore(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Routing.PageRouteHandler.#CheckUrlAccessWithAssert(System.String,System.Web.Routing.RequestContext,System.Security.Principal.IPrincipal)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Profile.ProfileModule.#PrepareDataForSaving(System.String&,System.String&,System.Byte[]&,System.Boolean,System.Configuration.SettingsPropertyValueCollection,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Profile.ProfileModule.#ParseDataFromDB(System.String[],System.String,System.Byte[],System.Configuration.SettingsPropertyValueCollection)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Profile.ProfileBase.#SetInternal(System.String,System.Object)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Profile.ProfileBase.#SaveWithAssert()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Util.VersionInfo.#GetFileVersion(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Util.FileUtil.#FileExists(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.Util.Debug.#TraceBreak(System.String,System.String,System.Exception,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.UI.WebControls.Substitution.#GetDelegate(System.Type,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.UI.Util.#VirtualFileExistsWithAssert(System.Web.VirtualPath)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2106:SecureAsserts", Scope = "member", Target = "System.Web.UI.Util.#SerializeWithAssert(System.Web.UI.IStateFormatter,System.Object)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#IsValidResource(System.IntPtr,System.IntPtr,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#IsUserInRole(System.IntPtr,System.String,System.Text.StringBuilder,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#IsapiAppHostGetSiteName(System.String,System.Text.StringBuilder,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#IsAccessToFileAllowed(System.IntPtr,System.IntPtr,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#InstrumentedMutexReleaseLock(System.Runtime.InteropServices.HandleRef)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#InstrumentedMutexGetLock(System.Runtime.InteropServices.HandleRef,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#InitializeWmiManager()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#InitializeHealthMonitor(System.Int32,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#GlobalMemoryStatusEx(System.Web.UnsafeNativeMethods+MEMORYSTATUSEX&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#GetSystemInfo(System.Web.UnsafeNativeMethods+SYSTEM_INFO&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#GetProcessAffinityMask(System.IntPtr,System.IntPtr&,System.IntPtr&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#GetGroupsForUser(System.IntPtr,System.Text.StringBuilder,System.Int32,System.Text.StringBuilder,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#GetFileSecurityDescriptor(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#GetFileHandleForTransmitFile(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#GetExtensionlessUrlAppendage()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#GetComputerName(System.Text.StringBuilder,System.Int32&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#GetCachePath(System.Int32,System.Text.StringBuilder,System.Int32&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#FreeFileSecurityDescriptor(System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#FindResource(System.IntPtr,System.IntPtr,System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#EcbCallISAPI(System.IntPtr,System.Web.UnsafeNativeMethods+CallISAPIFunc,System.Byte[],System.Int32,System.Byte[],System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#DoesKeyContainerExist(System.String,System.String,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#DirMonOpen(System.String,System.String,System.Boolean,System.UInt32,System.Int32,System.Web.NativeFileChangeNotification,System.IntPtr&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#CookieAuthParseTicket(System.Byte[],System.Int32,System.Text.StringBuilder,System.Int32,System.Text.StringBuilder,System.Int32,System.Text.StringBuilder,System.Int32,System.Byte[],System.Int64[])", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#CookieAuthConstructTicket(System.Byte[],System.Int32,System.String,System.String,System.String,System.Byte[],System.Int64[])", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#ConvertStringSidToSid(System.String,System.IntPtr&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#ChangeAccessToKeyContainer(System.String,System.String,System.String,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#BufferPoolGetBuffer(System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#AspCompatOnPageStart(System.Object)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#AspCompatIsApartmentComponent(System.Object)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportIsAuthenticated(System.IntPtr,System.Int32,System.Int32,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportHexPUID(System.IntPtr,System.Text.StringBuilder,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportHasTicket(System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportHasProfile(System.IntPtr,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportHasFlag(System.IntPtr,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportHasConsent(System.IntPtr,System.Int32,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportGetTimeSinceSignIn(System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportGetTicketAge(System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportGetProfile(System.IntPtr,System.String,System.Object&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportGetOption(System.IntPtr,System.String,System.Object&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportGetLoginChallenge(System.IntPtr,System.String,System.Int32,System.Int32,System.String,System.Int32,System.String,System.Int32,System.Int32,System.Object,System.Text.StringBuilder,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportGetHasSavedPassword(System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportGetFromNetworkServer(System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportGetError(System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportGetDomainAttribute(System.IntPtr,System.String,System.Int32,System.String,System.Text.StringBuilder,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportGetCurrentConfig(System.IntPtr,System.String,System.Object&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportDomainFromMemberName(System.IntPtr,System.String,System.Text.StringBuilder,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportDestroy(System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportCryptPut(System.Int32,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportCryptIsValid()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportCrypt(System.Int32,System.String,System.Text.StringBuilder,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportAuthURL2(System.IntPtr,System.String,System.Int32,System.Int32,System.String,System.Int32,System.String,System.Int32,System.Int32,System.Text.StringBuilder,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportAuthURL(System.IntPtr,System.String,System.Int32,System.Int32,System.String,System.Int32,System.String,System.Int32,System.Int32,System.Text.StringBuilder,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#lstrlenW(System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#LookupAccountSid(System.String,System.IntPtr,System.Text.StringBuilder,System.Int32&,System.Text.StringBuilder,System.Int32&,System.Int32&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#LogWebeventProviderFailure(System.String,System.String,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#LockResource(System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#LocalFree(System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#LoadResource(System.IntPtr,System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdGetBuffer(System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdFlushCore(System.IntPtr,System.Boolean,System.Int32,System.IntPtr[],System.Int32[],System.Int32[])", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdExplicitFlush(System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdExecuteUrl(System.IntPtr,System.String,System.Boolean,System.Boolean,System.Byte[],System.UInt32,System.String,System.Int32,System.String[],System.String[])", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdDisableNotifications(System.IntPtr,System.Web.RequestNotification,System.Web.RequestNotification)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdClearResponse(System.IntPtr,System.Boolean,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdAllocateRequestMemory(System.IntPtr,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.IProcessHostSupportFunctions.#MapPath(System.String,System.String,System.String&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.IProcessHostSupportFunctions.#GetRootWebConfigFilename()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.IProcessHostSupportFunctions.#GetNativeConfigurationSystem()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.IProcessHostSupportFunctions.#GetConfigToken(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.IProcessHostSupportFunctions.#GetApplicationProperties(System.String,System.String&,System.String&,System.String&,System.String&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.IProcessHostSupportFunctions.#GetAppHostConfigFilename()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#TransactManagedCallback(System.Web.Util.TransactedExecCallback,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#SizeofResource(System.IntPtr,System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#SetMinRequestsExecutingToDetectDeadlock(System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#SetClrThreadPoolLimits(System.Int32,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#RaiseWmiEvent(System.Web.UnsafeNativeMethods+WmiData&,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#RaiseEventlogEvent(System.Int32,System.String[],System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PostThreadPoolWorkItem(System.Web.Util.WorkItemCallback)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PMGetMemoryLimitInMB()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PerfSetCounter(System.IntPtr,System.Int32,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PerfGetCounter(System.IntPtr,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportVersion()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportTicket(System.IntPtr,System.String,System.Object&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportSetOption(System.IntPtr,System.String,System.Object)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportLogoutURL(System.IntPtr,System.String,System.String,System.Int32,System.String,System.Int32,System.Text.StringBuilder,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportLogoTag2(System.IntPtr,System.String,System.Int32,System.Int32,System.String,System.Int32,System.Int32,System.String,System.Int32,System.Int32,System.Text.StringBuilder,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.UnsafeNativeMethods.#PassportLogoTag(System.IntPtr,System.String,System.Int32,System.Int32,System.String,System.Int32,System.Int32,System.String,System.Int32,System.Int32,System.Text.StringBuilder,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdSetUnknownHeader(System.IntPtr,System.Boolean,System.Boolean,System.Byte[],System.Byte[],System.UInt16)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdSetServerVariableW(System.IntPtr,System.String,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdGetServerVariableW(System.IntPtr,System.String,System.IntPtr&,System.Int32&)", Justification = "Not a dangerous method; all callers check parameters.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdSetResponseFilter(System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdSetRemapHandler(System.IntPtr,System.String,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdSetNativeConfiguration(System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdSetKnownHeader(System.IntPtr,System.Boolean,System.Boolean,System.UInt16,System.Byte[],System.UInt16)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdRewriteUrl(System.IntPtr,System.String,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdReadChunkHandle(System.IntPtr,System.IntPtr,System.Int64,System.Int32&,System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdMapHandler(System.IntPtr,System.String,System.String,System.IntPtr&,System.Int32&,System.Boolean,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdIsClientConnected(System.IntPtr)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdInitNativeConfig()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdGetStopListeningEventHandle()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdGetSiteNameFromId(System.UInt32,System.IntPtr&,System.Int32&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdGetResponseChunks(System.IntPtr,System.Int32&,System.IntPtr[],System.Int32[],System.Int32[])", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdGetNextModule(System.IntPtr,System.UInt32&,System.IntPtr&,System.Int32&,System.IntPtr&,System.Int32&,System.IntPtr&,System.Int32&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdGetModuleCollection(System.IntPtr,System.IntPtr&,System.Int32&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdGetMaxConcurrentThreadsPerCPU()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdGetMaxConcurrentRequestsPerCPU()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2118:ReviewSuppressUnmanagedCodeSecurityUsage", Scope = "member", Target = "System.Web.Hosting.UnsafeIISMethods.#MgdGetFileChunkInfo(System.IntPtr,System.Int32,System.Int64&,System.Int64&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2116:AptcaMethodsShouldOnlyCallAptcaMethods", Scope = "member", Target = "MTConfigUtil.#get_MachineConfigPath()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2116:AptcaMethodsShouldOnlyCallAptcaMethods", Scope = "member", Target = "System.Web.Compilation.AssemblyResolver.#GetPathToReferenceAssemblies(System.Runtime.Versioning.FrameworkName)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2116:AptcaMethodsShouldOnlyCallAptcaMethods", Scope = "member", Target = "System.Web.Compilation.AssemblyResolver.#ResolveAssembly(System.String,System.Collections.Generic.IList`1<System.String>,System.Collections.Generic.IList`1<System.String>,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2116:AptcaMethodsShouldOnlyCallAptcaMethods", Scope = "member", Target = "System.Web.Compilation.AssemblyResolver.#get_TargetFrameworkReferenceAssemblyPaths()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2116:AptcaMethodsShouldOnlyCallAptcaMethods", Scope = "member", Target = "System.Web.Compilation.MultiTargetingUtil.#InitializeKnownAndLatestFrameworkNames()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Security", "CA2116:AptcaMethodsShouldOnlyCallAptcaMethods", Scope = "member", Target = "System.Web.Configuration.WebConfigurationHost.#GetMachineConfigPathFromTargetFrameworkMoniker(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WebBaseEvent.#RaiseInternal(System.Web.Management.WebBaseEvent,System.Collections.ArrayList,System.Int32,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int64.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WebBaseEvent.#GenerateFieldsForMarshal(System.Collections.Generic.List`1<System.Web.Management.WebEventFieldData>)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WebBaseEvent.#GenerateFieldsForMarshal(System.Collections.Generic.List`1<System.Web.Management.WebEventFieldData>)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int64.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WebBaseEvent.#FormatToString(System.Web.Management.WebEventFormatter,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WebBaseEvent.#FormatToString(System.Web.Management.WebEventFormatter,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Guid.ToString(System.String,System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WebBaseEvent.#FormatToString(System.Web.Management.WebEventFormatter,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.DateTime.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WebBaseEvent.#FormatToString(System.Web.Management.WebEventFormatter,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WebBaseErrorEvent.#FormatToString(System.Web.Management.WebEventFormatter,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.TemplatedMailWebEventProvider.#GenerateMessageBody(System.Net.Mail.MailMessage,System.Web.Management.WebBaseEventCollection,System.DateTime,System.Int32,System.Int32,System.Int32,System.Web.Management.EventNotificationType,System.Int32,System.Int32,System.Int32,System.Int32,System.Int32,System.Boolean&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.IO.StringWriter.#ctor(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.TemplatedMailWebEventProvider.#GenerateMessageBody(System.Net.Mail.MailMessage,System.Web.Management.WebBaseEventCollection,System.DateTime,System.Int32,System.Int32,System.Int32,System.Web.Management.EventNotificationType,System.Int32,System.Int32,System.Int32,System.Int32,System.Int32,System.Boolean&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.TemplatedMailRuntimeErrorFormatter.#get_ErrorTitle()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.TemplatedMailCompileErrorFormatter.#get_ErrorTitle()", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.SqlWebEventProvider.#WriteToSQL(System.Web.Management.WebBaseEventCollection,System.Int32,System.DateTime)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.DateTime.ToString(System.String,System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.SqlWebEventProvider.#WriteToSQL(System.Web.Management.WebBaseEventCollection,System.Int32,System.DateTime)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Guid.ToString(System.String,System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.SqlWebEventProvider.#FillParams(System.Data.SqlClient.SqlCommand,System.Web.Management.WebBaseEvent)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.SimpleMailWebEventProvider.#GenerateWarnings(System.Text.StringBuilder,System.DateTime,System.Int32,System.Int32,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.DateTime.ToString(System.String,System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.SimpleMailWebEventProvider.#GenerateWarnings(System.Text.StringBuilder,System.DateTime,System.Int32,System.Int32,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.SimpleMailWebEventProvider.#GenerateSummary(System.Text.StringBuilder,System.Int32,System.Int32,System.Int32,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.MailWebEventProvider.#GenerateSubject(System.Int32,System.Int32,System.Web.Management.WebBaseEventCollection,System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.String,System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.EventLogWebEventProvider.#ProcessEvent(System.Web.Management.WebBaseEvent)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.EventLogWebEventProvider.#AddWebThreadInformationDataFields(System.Collections.ArrayList,System.Web.Management.WebThreadInformation)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Boolean.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.EventLogWebEventProvider.#AddWebThreadInformationDataFields(System.Collections.ArrayList,System.Web.Management.WebThreadInformation)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int64.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.EventLogWebEventProvider.#AddWebProcessStatisticsDataFields(System.Collections.ArrayList,System.Web.Management.WebProcessStatistics)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.EventLogWebEventProvider.#AddWebProcessStatisticsDataFields(System.Collections.ArrayList,System.Web.Management.WebProcessStatistics)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.DateTime.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.EventLogWebEventProvider.#AddWebProcessStatisticsDataFields(System.Collections.ArrayList,System.Web.Management.WebProcessStatistics)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.EventLogWebEventProvider.#AddWebProcessInformationDataFields(System.Collections.ArrayList,System.Web.Management.WebProcessInformation)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int64.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.EventLogWebEventProvider.#AddBasicDataFields(System.Collections.ArrayList,System.Web.Management.WebBaseEvent)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.EventLogWebEventProvider.#AddBasicDataFields(System.Collections.ArrayList,System.Web.Management.WebBaseEvent)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Guid.ToString(System.String,System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.EventLogWebEventProvider.#AddBasicDataFields(System.Collections.ArrayList,System.Web.Management.WebBaseEvent)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WebErrorEvent.#GenerateFieldsForMarshal(System.Collections.Generic.List`1<System.Web.Management.WebEventFieldData>)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WebManagementEvent.#GenerateFieldsForMarshal(System.Collections.Generic.List`1<System.Web.Management.WebEventFieldData>)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WebProcessInformation.#FormatToString(System.Web.Management.WebEventFormatter)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.DateTime.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WebProcessStatistics.#FormatToString(System.Web.Management.WebEventFormatter)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WebProcessStatistics.#FormatToString(System.Web.Management.WebEventFormatter)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int64.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WebProcessStatistics.#FormatToString(System.Web.Management.WebEventFormatter)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WebRequestErrorEvent.#GenerateFieldsForMarshal(System.Collections.Generic.List`1<System.Web.Management.WebEventFieldData>)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WebThreadInformation.#FormatToString(System.Web.Management.WebEventFormatter)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Guid.ToString(System.String,System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WmiWebEventProvider.#FillBasicWmiDataFields(System.Web.UnsafeNativeMethods+WmiData&,System.Web.Management.WebBaseEvent)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int64.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WmiWebEventProvider.#FillBasicWmiDataFields(System.Web.UnsafeNativeMethods+WmiData&,System.Web.Management.WebBaseEvent)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int32.ToString(System.String,System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WmiWebEventProvider.#ProcessEvent(System.Web.Management.WebBaseEvent)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.Int64.ToString(System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WmiWebEventProvider.#ProcessEvent(System.Web.Management.WebBaseEvent)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Globalization", "CA1305:SpecifyIFormatProvider", MessageId = "System.DateTime.ToString(System.String,System.IFormatProvider)", Scope = "member", Target = "System.Web.Management.WmiWebEventProvider.#WmiFormatTime(System.DateTime)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA2208:InstantiateArgumentExceptionsCorrectly", Scope = "member", Target = "System.Web.Util.FastPropertyAccessor.#SetProperty(System.Object,System.String,System.Object,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA2208:InstantiateArgumentExceptionsCorrectly", Scope = "member", Target = "System.Web.Util.FastPropertyAccessor.#GetPropertyInfo(System.Type,System.String,System.Reflection.PropertyInfo&,System.Reflection.FieldInfo&,System.Type&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA2208:InstantiateArgumentExceptionsCorrectly", Scope = "member", Target = "System.Web.Util.FastPropertyAccessor.#GetProperty(System.Object,System.String,System.Boolean)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA2208:InstantiateArgumentExceptionsCorrectly", Scope = "member", Target = "System.Web.UI.WebControls.TextBox.#set_Rows(System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA2208:InstantiateArgumentExceptionsCorrectly", Scope = "member", Target = "System.Web.UI.WebControls.TextBox.#set_Columns(System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA2208:InstantiateArgumentExceptionsCorrectly", Scope = "member", Target = "System.Web.UI.WebControls.Menu.#set_MaximumDynamicDisplayLevels(System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA2208:InstantiateArgumentExceptionsCorrectly", Scope = "member", Target = "System.Web.UI.Page.#set_Theme(System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA2208:InstantiateArgumentExceptionsCorrectly", Scope = "member", Target = "System.Web.UI.Page.#set_MaxPageStateFieldLength(System.Int32)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA2208:InstantiateArgumentExceptionsCorrectly", Scope = "member", Target = "System.Web.UI.Page.#set_AsyncTimeout(System.TimeSpan)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA2208:InstantiateArgumentExceptionsCorrectly", Scope = "member", Target = "System.Web.Security.SqlMembershipProvider.#GetAllUsers(System.Int32,System.Int32,System.Int32&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA2208:InstantiateArgumentExceptionsCorrectly", Scope = "member", Target = "System.Web.Security.SqlMembershipProvider.#FindUsersByName(System.String,System.Int32,System.Int32,System.Int32&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA2208:InstantiateArgumentExceptionsCorrectly", Scope = "member", Target = "System.Web.Security.SqlMembershipProvider.#FindUsersByEmail(System.String,System.Int32,System.Int32,System.Int32&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA2208:InstantiateArgumentExceptionsCorrectly", Scope = "member", Target = "System.Web.Security.ActiveDirectoryMembershipProvider.#UpdateUser(System.Web.Security.MembershipUser)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA2208:InstantiateArgumentExceptionsCorrectly", Scope = "member", Target = "System.Web.Security.ActiveDirectoryMembershipProvider.#FindUsersByName(System.String,System.Int32,System.Int32,System.Int32&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA2208:InstantiateArgumentExceptionsCorrectly", Scope = "member", Target = "System.Web.Security.ActiveDirectoryMembershipProvider.#FindUsersByEmail(System.String,System.Int32,System.Int32,System.Int32&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA2208:InstantiateArgumentExceptionsCorrectly", Scope = "member", Target = "System.Web.Profile.SqlProfileProvider.#GetProfilesForQuery(System.Data.SqlClient.SqlParameter[],System.Web.Profile.ProfileAuthenticationOption,System.Int32,System.Int32,System.Int32&)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA2208:InstantiateArgumentExceptionsCorrectly", Scope = "member", Target = "System.Web.Configuration.BufferModeSettings.#Validate(System.Object)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA2208:InstantiateArgumentExceptionsCorrectly", Scope = "member", Target = "System.Web.Caching.SqlCacheDependencyAdmin.#SetupNotifications(System.Int32,System.String,System.String)", Justification = "Has been reviewed.")]
[module: SuppressMessage("Microsoft.Usage", "CA2208:InstantiateArgumentExceptionsCorrectly", Scope = "member", Target = "System.Web.HttpSubstBlockResponseElement.#.ctor(System.Web.HttpResponseSubstitutionCallback,System.Text.Encoding,System.Text.Encoder,System.Web.Hosting.IIS7WorkerRequest)", Justification = "Has been reviewed.")]
#endregion

#region Low-priority items for review
[module: SuppressMessage("Microsoft.Naming", "CA1701:ResourceStringCompoundWordsShouldBeCasedCorrectly", MessageId = "Databinding", Scope = "resource", Target = "System.Web.Resources.WebResources.resources", Justification = "Baselined from previous FxCop.")]
[module: SuppressMessage("Microsoft.Naming", "CA1701:ResourceStringCompoundWordsShouldBeCasedCorrectly", MessageId = "assemblyname", Scope = "resource", Target = "System.Web.Resources.WebResources.resources", Justification = "Baselined from previous FxCop.")]
[module: SuppressMessage("Microsoft.Naming", "CA1701:ResourceStringCompoundWordsShouldBeCasedCorrectly", MessageId = "databind", Scope = "resource", Target = "System.Web.Resources.WebResources.resources", Justification = "Baselined from previous FxCop.")]
[module: SuppressMessage("Microsoft.Naming", "CA1701:ResourceStringCompoundWordsShouldBeCasedCorrectly", MessageId = "databinding", Scope = "resource", Target = "System.Web.Resources.WebResources.resources", Justification = "Baselined from previous FxCop.")]
[module: SuppressMessage("Microsoft.Naming", "CA1701:ResourceStringCompoundWordsShouldBeCasedCorrectly", MessageId = "newline", Scope = "resource", Target = "System.Web.Resources.WebResources.resources", Justification = "Baselined from previous FxCop.")]
[module: SuppressMessage("Microsoft.Naming", "CA1701:ResourceStringCompoundWordsShouldBeCasedCorrectly", MessageId = "readonly", Scope = "resource", Target = "System.Web.Resources.WebResources.resources", Justification = "Baselined from previous FxCop.")]
[module: SuppressMessage("Microsoft.Naming", "CA1701:ResourceStringCompoundWordsShouldBeCasedCorrectly", MessageId = "stylesheet", Scope = "resource", Target = "System.Web.Resources.WebResources.resources", Justification = "Baselined from previous FxCop.")]
#endregion
