//------------------------------------------------------------------------------
// <copyright file="DataControlCommands.cs" company="Microsoft">
//     Copyright (c) Microsoft Corporation.  All rights reserved.
// </copyright>                                                                
//------------------------------------------------------------------------------
namespace System.Web.UI.WebControls {

    public sealed class DataControlCommands {
        
        private DataControlCommands() {}
        

        /// <devdoc>
        /// <para> Specifies the <see langword='Sort'/> command. This field is constant.</para>
        /// </devdoc>
        public const string SortCommandName = "Sort";

        /// <devdoc>
        /// <para> Specifies the <see langword='Select '/> command. This field is constant.</para>
        /// </devdoc>
        public const string SelectCommandName = "Select";

        /// <devdoc>
        /// <para> Specifies the <see langword='Edit'/> command. This field is constant.</para>
        /// </devdoc>
        public const string EditCommandName = "Edit";

        /// <devdoc>
        /// <para> Specifies the <see langword='Delete'/> command. This field is constant.</para>
        /// </devdoc>
        public const string DeleteCommandName = "Delete";

        /// <devdoc>
        /// <para> Specifies the <see langword='Update'/> command. This field is constant.</para>
        /// </devdoc>
        public const string UpdateCommandName = "Update";

        /// <devdoc>
        /// <para> Specifies the <see langword='Cancel'/> command. This field is constant.</para>
        /// </devdoc>
        public const string CancelCommandName = "Cancel";

        /// <devdoc>
        /// <para> Specifies the <see langword='Page '/> command. This field is constant.</para>
        /// </devdoc>
        public const string PageCommandName = "Page";

        /// <devdoc>
        /// <para> Specifies the <see langword='Next Page'/> argument. This field is constant.</para>
        /// </devdoc>
        public const string NextPageCommandArgument = "Next";

        /// <devdoc>
        /// <para> Specifies the <see langword='Previous Page'/> argument. This field is constant.</para>
        /// </devdoc>
        public const string PreviousPageCommandArgument = "Prev";

        /// <devdoc>
        /// <para> Specifies the <see langword='First Page'/> argument. This field is constant.</para>
        /// </devdoc>
        public const string FirstPageCommandArgument = "First";

        /// <devdoc>
        /// <para> Specifies the <see langword='Last Page'/> argument. This field is constant.</para>
        /// </devdoc>
        public const string LastPageCommandArgument = "Last";

        /// <devdoc>
        /// <para> Specifies the <see langword='Insert'/> command. This field is constant.</para>
        /// </devdoc>
        public const string InsertCommandName = "Insert";

        /// <devdoc>
        /// <para> Specifies the <see langword='New'/> command. This field is constant.</para>
        /// </devdoc>
        public const string NewCommandName = "New";

    }
}
